import 'package:flutter/cupertino.dart';
import 'package:flutter_easy_utils/flutter_easy_utils.dart';
import 'package:flutter_easy_utils/src/providers/UtilsProvider.dart';
import 'package:provider/provider.dart';

/// get home page for Material App
class Home extends StatefulWidget {
  /// check version for updates
  final bool checkVersion;

  /// check age +18
  final bool checkAge;

  /// builder for home page
  final Widget Function(BuildContext context) builder;

  const Home(
      {Key key,
      this.checkVersion: true,
      this.checkAge: false,
      @required this.builder})
      : super(key: key);

  @override
  _HomeState createState() => _HomeState();
}

class _HomeState extends State<Home> {
  @override
  void initState() {
    /// init check version
    if (widget.checkVersion) {
      checkVersion(context);
    }

    /// init check age
    if (widget.checkAge) {
      confirmAge(context);
    }

    /// init internet check
    Provider.of<UtilsProvider>(context, listen: false).initInternet(context);

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    /// init the size config for the dimensions
    SizeConfig.init(context);

    /// return your builder app
    return widget.builder(context);
  }
}
